Index: src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -40,8 +40,8 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionNotMoleculeByFormulaAction::performCall() {
-  LOG(1, "Unselecting molecules with chemical formula " << params.formula << ":");
-  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(params.formula));
+  LOG(1, "Unselecting molecules with chemical formula " << params.formula.get() << ":");
+  std::vector<molecule *> matchingMolecules = World::getInstance().getAllMolecules(MoleculeByFormula(params.formula.get()));
   std::vector<molecule *> unselectedMolecules = World::getInstance().getAllMolecules(!MoleculesBySelection());
-  World::getInstance().unselectAllMolecules(MoleculeByFormula(params.formula));
+  World::getInstance().unselectAllMolecules(MoleculeByFormula(params.formula.get()));
   LOG(0, World::getInstance().countSelectedMolecules() << " molecules remain selected.");
   return Action::state_ptr(new SelectionNotMoleculeByFormulaState(unselectedMolecules,params));
@@ -51,5 +51,5 @@
   SelectionNotMoleculeByFormulaState *state = assert_cast<SelectionNotMoleculeByFormulaState*>(_state.get());
 
-  World::getInstance().selectAllMolecules(MoleculeByFormula(state->params.formula));
+  World::getInstance().selectAllMolecules(MoleculeByFormula(state->params.formula.get()));
   BOOST_FOREACH( molecule *mol, state->unselectedMolecules)
     World::getInstance().unselectMolecule(mol);
@@ -61,5 +61,5 @@
   SelectionNotMoleculeByFormulaState *state = assert_cast<SelectionNotMoleculeByFormulaState*>(_state.get());
 
-  World::getInstance().unselectAllMolecules(MoleculeByFormula(state->params.formula));
+  World::getInstance().unselectAllMolecules(MoleculeByFormula(state->params.formula.get()));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByFormulaAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class molecule;
 
+#include "Parameters/Validators/Specific/FormulaValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::string)
 #define paramtokens ("unselect-molecules-by-formula")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (formula)
+#define paramvalids \
+(FormulaValidator())
 
 #define statetypes (std::vector<molecule*>)
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -38,9 +38,9 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionNotMoleculeByIdAction::performCall() {
-  const molecule *mol = World::getInstance().getMolecule(MoleculeById(params.molindex));
+  const molecule *mol = World::getInstance().getMolecule(MoleculeById(params.molindex.get()));
   if (mol != NULL) {
     if (World::getInstance().isSelected(mol)) {
       LOG(1, "Unselecting molecule " << mol->name);
-      World::getInstance().unselectAllMolecules(MoleculeById(params.molindex));
+      World::getInstance().unselectAllMolecules(MoleculeById(params.molindex.get()));
       LOG(0, World::getInstance().countSelectedMolecules() << " molecules remain selected.");
       return Action::state_ptr(new SelectionNotMoleculeByIdState(params));
@@ -56,5 +56,5 @@
   SelectionNotMoleculeByIdState *state = assert_cast<SelectionNotMoleculeByIdState*>(_state.get());
 
-  World::getInstance().selectAllMolecules(MoleculeById(state->params.molindex));
+  World::getInstance().selectAllMolecules(MoleculeById(state->params.molindex.get()));
 
   return Action::state_ptr(_state);
@@ -64,5 +64,5 @@
   SelectionNotMoleculeByIdState *state = assert_cast<SelectionNotMoleculeByIdState*>(_state.get());
 
-  World::getInstance().unselectAllMolecules(MoleculeById(state->params.molindex));
+  World::getInstance().unselectAllMolecules(MoleculeById(state->params.molindex.get()));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByIdAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,14 +7,18 @@
 
 // all includes and forward declarations necessary for non-integral types below
-class molecule;
+#include "types.hpp"
+
+#include "Parameters/Validators/Specific/MoleculeIdValidator.hpp"
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (int)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (moleculeId_t)
 #define paramtokens ("unselect-molecule-by-id")
 #define paramdescriptions ("molecule index")
 #undef paramdefaults
 #define paramreferences (molindex)
+#define paramvalids \
+(MoleculeIdValidator())
 
 #undef statetypes
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -40,8 +40,8 @@
 /** =========== define the function ====================== */
 Action::state_ptr SelectionNotMoleculeByNameAction::performCall() {
-  LOG(1, "Unselecting all molecule called " << params.molname);
+  LOG(1, "Unselecting all molecule called " << params.molname.get());
   std::vector<molecule *> unselectedMolecules =
-      World::getInstance().getAllMolecules((!MoleculesBySelection()) && MoleculeByName(params.molname));
-  World::getInstance().unselectAllMolecules(MoleculeByName(params.molname));
+      World::getInstance().getAllMolecules((!MoleculesBySelection()) && MoleculeByName(params.molname.get()));
+  World::getInstance().unselectAllMolecules(MoleculeByName(params.molname.get()));
   LOG(0, World::getInstance().countSelectedMolecules() << " molecules remain selected.");
 
@@ -52,5 +52,5 @@
   SelectionNotMoleculeByNameState *state = assert_cast<SelectionNotMoleculeByNameState*>(_state.get());
 
-  World::getInstance().selectAllMolecules(MoleculeByName(state->params.molname));
+  World::getInstance().selectAllMolecules(MoleculeByName(state->params.molname.get()));
   BOOST_FOREACH( molecule *mol, state->unselectedMolecules)
     World::getInstance().unselectMolecule(mol);
@@ -62,5 +62,5 @@
   SelectionNotMoleculeByNameState *state = assert_cast<SelectionNotMoleculeByNameState*>(_state.get());
 
-  World::getInstance().unselectAllMolecules(MoleculeByName(state->params.molname));
+  World::getInstance().unselectAllMolecules(MoleculeByName(state->params.molname.get()));
 
   return Action::state_ptr(_state);
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByNameAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class molecule;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::string)
 #define paramtokens ("unselect-molecules-by-name")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (molname)
+#define paramvalids \
+(DummyValidator< std::string >())
 
 #define statetypes (std::vector<molecule *>)
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.cpp
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -39,5 +39,5 @@
 
 Action::state_ptr SelectionNotMoleculeByOrderAction::performCall() {
-  molecule *mol = World::getInstance().getMolecule(MoleculeByOrder(params.molindex));
+  molecule *mol = World::getInstance().getMolecule(MoleculeByOrder(params.molindex.get()));
 
   if (mol != NULL) {
Index: src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class molecule;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (int)
 #define paramtokens ("unselect-molecule-by-order")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (molindex)
+#define paramvalids \
+(DummyValidator< int >())
 
 #define statetypes (const molecule *)
Index: src/Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.def
===================================================================
--- src/Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -16,4 +18,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector<molecule*>)
Index: src/Actions/TesselationAction/ConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -50,6 +50,6 @@
     const LinkedCell_deprecated *LCList = NULL;
     LOG(0, "Evaluating volume of the convex envelope.");
-    LOG(1, "Storing tecplot convex data in " << params.filenameConvex << ".");
-    LOG(1, "Storing tecplot non-convex data in " << params.filenameNonConvex << ".");
+    LOG(1, "Storing tecplot convex data in " << params.filenameConvex.get() << ".");
+    LOG(1, "Storing tecplot non-convex data in " << params.filenameNonConvex.get() << ".");
     PointCloudAdaptor<molecule> cloud(mol, mol->name);
     LCList = new LinkedCell_deprecated(cloud, 100.);
@@ -57,7 +57,7 @@
     //FindConvexBorder(mol, BoundaryPoints, TesselStruct, LCList, argv[argptr]);
     // TODO: Beide Funktionen sollten streams anstelle des Filenamen benutzen, besser fuer unit tests
-    FindNonConvexBorder(mol, TesselStruct, LCList, 50., params.filenameNonConvex.string().c_str());
+    FindNonConvexBorder(mol, TesselStruct, LCList, 50., params.filenameNonConvex.get().string().c_str());
     //RemoveAllBoundaryPoints(TesselStruct, mol, argv[argptr]);
-    const double volumedifference = ConvexizeNonconvexEnvelope(TesselStruct, mol, params.filenameConvex.string().c_str());
+    const double volumedifference = ConvexizeNonconvexEnvelope(TesselStruct, mol, params.filenameConvex.get().string().c_str());
     const double clustervolume = TesselStruct->getVolumeOfConvexEnvelope(configuration->GetIsAngstroem());
     LOG(0, "The tesselated volume area is " << clustervolume << " " << (configuration->GetIsAngstroem() ? "angstrom" : "atomiclength") << "^3.");
Index: src/Actions/TesselationAction/ConvexEnvelopeAction.def
===================================================================
--- src/Actions/TesselationAction/ConvexEnvelopeAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/TesselationAction/ConvexEnvelopeAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,10 @@
 class TesselationListClass;
 
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (boost::filesystem::path)(boost::filesystem::path)
 #define paramtokens ("convex-file")("nonconvex-file")
@@ -17,4 +20,7 @@
 #undef paramdefaults
 #define paramreferences (filenameConvex)(filenameNonConvex)
+#define paramvalids \
+(!FilePresentValidator()) \
+(!FilePresentValidator())
 
 #undef statetypes
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -49,11 +49,11 @@
     const LinkedCell_deprecated *LCList = NULL;
     LOG(0, "Evaluating non-convex envelope of molecule." << Boundary->getId());
-    LOG(1, "Using rolling ball of radius " << params.SphereRadius << " and storing tecplot data in " << params.filename << ".");
+    LOG(1, "Using rolling ball of radius " << params.SphereRadius.get() << " and storing tecplot data in " << params.filename.get() << ".");
     LOG(1, "Specified molecule has " << Boundary->getAtomCount() << " atoms.");
     start = clock();
     PointCloudAdaptor< molecule > cloud(Boundary, Boundary->name);
-    LCList = new LinkedCell_deprecated(cloud, params.SphereRadius*2.);
-    Success = FindNonConvexBorder(Boundary, T, LCList, params.SphereRadius, params.filename.string().c_str());
-    //FindDistributionOfEllipsoids(T, &LCList, N, number, params.filename.c_str());
+    LCList = new LinkedCell_deprecated(cloud, params.SphereRadius.get()*2.);
+    Success = FindNonConvexBorder(Boundary, T, LCList, params.SphereRadius.get(), params.filename.get().string().c_str());
+    //FindDistributionOfEllipsoids(T, &LCList, N, number, params.filename.get().c_str());
     end = clock();
     LOG(0, "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s.");
Index: src/Actions/TesselationAction/NonConvexEnvelopeAction.def
===================================================================
--- src/Actions/TesselationAction/NonConvexEnvelopeAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/TesselationAction/NonConvexEnvelopeAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,11 @@
 class TesselationListClass;
 
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (double)(boost::filesystem::path)
 #define paramtokens ("nonconvex-envelope")("nonconvex-file")
@@ -17,4 +21,7 @@
 #undef paramdefaults
 #define paramreferences (SphereRadius)(filename)
+#define paramvalids \
+(BoxLengthValidator()) \
+(!FilePresentValidator())
 
 #undef statetypes
Index: src/Actions/UndoAction.def
===================================================================
--- src/Actions/UndoAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/UndoAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,7 +8,9 @@
 // all includes and forward declarations necessary for non-integral types below
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramreferences
Index: src/Actions/UndoRedoHelpers.cpp
===================================================================
--- src/Actions/UndoRedoHelpers.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/UndoRedoHelpers.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -26,5 +26,7 @@
 
 #include "Atom/atom.hpp"
+#include "molecule.hpp"
 #include "Descriptors/AtomIdDescriptor.hpp"
+#include "Descriptors/MoleculeIdDescriptor.hpp"
 #include "CodePatterns/Assert.hpp"
 #include "CodePatterns/Log.hpp"
@@ -123,2 +125,14 @@
   }
 }
+
+void MoleCuilder::RemoveMoleculesWithAtomsByIds(const std::vector<moleculeId_t> &ids)
+{
+  for (std::vector<moleculeId_t>::const_iterator iter = ids.begin();
+      iter != ids.end(); ++iter) {
+    molecule * const mol = World::getInstance().getMolecule(MoleculeById(*iter));
+    if (mol != NULL) {
+      mol->removeAtomsinMolecule();
+      World::getInstance().destroyMolecule(mol);
+    }
+  }
+}
Index: src/Actions/UndoRedoHelpers.hpp
===================================================================
--- src/Actions/UndoRedoHelpers.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/UndoRedoHelpers.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -70,4 +70,10 @@
    */
   void ResetAtomPosition(const std::vector<AtomicInfo> &movedatoms, const std::vector<Vector> &MovedToVector);
+
+  /** Remove all molecules identified by their ids given in \a ids.
+   *
+   * @param ids vector of molecular ids to remove
+   */
+  void RemoveMoleculesWithAtomsByIds(const std::vector<moleculeId_t> &ids);
 }
 
Index: src/Actions/Values.cpp
===================================================================
--- src/Actions/Values.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/Values.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -47,8 +47,8 @@
 }
 
-Box BoxValue::toBox() const
+RealSpaceMatrix RealSpaceMatrixValue::toRealSpaceMatrix() const
 {
-  Box returnBox(ReturnFullMatrixforSymmetric(matrix));
+  RealSpaceMatrix returnMatrix(ReturnFullMatrixforSymmetric(matrix));
 
-  return returnBox;
+  return returnMatrix;
 }
Index: src/Actions/Values.hpp
===================================================================
--- src/Actions/Values.hpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/Values.hpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -18,4 +18,5 @@
 class Box;
 class BoxVector;
+class RealSpaceMatrix;
 class Vector;
 
@@ -37,9 +38,9 @@
  * as BoxValue and lateron inside the CommandLineQuery placed into the real Box.
  */
-struct BoxValue
+struct RealSpaceMatrixValue
 {
   double matrix[(NDIM*(NDIM+1))/2];
 
-  Box toBox() const;
+  RealSpaceMatrix toRealSpaceMatrix() const;
 };
 
Index: src/Actions/WorldAction/AddEmptyBoundaryAction.cpp
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -77,5 +77,5 @@
     for (int i=0;i<NDIM;i++) {
       j += i+1;
-      cell_size[j] = (Max[i]-Min[i]+2.*params.boundary[i]);
+      cell_size[j] = (Max[i]-Min[i]+2.*params.boundary.get()[i]);
     }
     World::getInstance().setDomain(cell_size);
@@ -86,5 +86,5 @@
         AtomRunner != AllAtoms.end();
         ++AtomRunner)
-      *(*AtomRunner) -= Min - params.boundary;
+      *(*AtomRunner) -= Min - params.boundary.get();
 
     // give final box size
@@ -125,5 +125,5 @@
       AtomRunner != AllAtoms.end();
       ++AtomRunner)
-    *(*AtomRunner) += state->Min - state->params.boundary;
+    *(*AtomRunner) += state->Min - state->params.boundary.get();
 
   return Action::state_ptr(_state);
@@ -143,5 +143,5 @@
       AtomRunner != AllAtoms.end();
       ++AtomRunner)
-    *(*AtomRunner) -= state->Min - state->params.boundary;
+    *(*AtomRunner) -= state->Min - state->params.boundary.get();
 
   return Action::state_ptr(_state);
Index: src/Actions/WorldAction/AddEmptyBoundaryAction.def
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -11,7 +11,9 @@
 #include "LinearAlgebra/Vector.hpp"
 
+#include "Parameters/Validators/Specific/VectorPositiveComponentsValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (Vector)
 #define paramtokens ("add-empty-boundary")
@@ -19,4 +21,6 @@
 #undef paramdefaults
 #define paramreferences (boundary)
+#define paramvalids \
+(VectorPositiveComponentsValidator())
 
 #define statetypes (std::string)(RealSpaceMatrix)(Vector)
Index: src/Actions/WorldAction/BoundInBoxAction.def
===================================================================
--- src/Actions/WorldAction/BoundInBoxAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/BoundInBoxAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -11,7 +11,9 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -19,4 +21,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::vector< boost::shared_ptr<Vector> >)
Index: src/Actions/WorldAction/CenterInBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/CenterInBoxAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -69,5 +69,5 @@
 
   // set new domain
-  World::getInstance().setDomain(params.cell_size.getM());
+  World::getInstance().setDomain(params.cell_size.get());
 
   // center atoms
@@ -125,5 +125,5 @@
 
   // set new domain
-  World::getInstance().setDomain(state->params.cell_size.getM());
+  World::getInstance().setDomain(state->params.cell_size.get());
 
   // center atoms
Index: src/Actions/WorldAction/CenterInBoxAction.def
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/CenterInBoxAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,17 +7,20 @@
 
 // all includes and forward declarations necessary for non-integral types below
-#include "Actions/Values.hpp"
-#include "Box.hpp"
-#include "LinearAlgebra/Vector.hpp"
-#include <boost/shared_ptr.hpp>
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/RealSpaceMatrixSymmetricValidator.hpp"
+#include "Parameters/Validators/Specific/RealSpaceMatrixInvertibleValidator.hpp"
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (Box)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (RealSpaceMatrix)
 #define paramtokens ("center-in-box")
 #define paramdescriptions ("symmetric matrix of new domain")
 #undef paramdefaults
 #define paramreferences (cell_size)
+#define paramvalids \
+(RealSpaceMatrixSymmetricValidator() && RealSpaceMatrixInvertibleValidator())
 
 #define statetypes (std::string)(std::vector< boost::shared_ptr<Vector> >)
Index: src/Actions/WorldAction/CenterOnEdgeAction.def
===================================================================
--- src/Actions/WorldAction/CenterOnEdgeAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/CenterOnEdgeAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 #include "LinearAlgebra/Vector.hpp"
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -17,4 +19,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (std::string)(Vector)(Vector)
Index: src/Actions/WorldAction/ChangeBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/ChangeBoxAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/ChangeBoxAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -50,5 +50,5 @@
   oa << matrix;
 
-  World::getInstance().setDomain(params.cell_size.getM()); // this is needed as only this function is OBSERVEd.
+  World::getInstance().setDomain(params.cell_size.get()); // this is needed as only this function is OBSERVEd.
 
   // give final box size
@@ -82,5 +82,5 @@
 
 Action::state_ptr WorldChangeBoxAction::performRedo(Action::state_ptr _state){
-  World::getInstance().setDomain(params.cell_size.getM()); // this is needed as only this function is OBSERVEd.
+  World::getInstance().setDomain(params.cell_size.get()); // this is needed as only this function is OBSERVEd.
 
   // give final box size
Index: src/Actions/WorldAction/ChangeBoxAction.def
===================================================================
--- src/Actions/WorldAction/ChangeBoxAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/WorldAction/ChangeBoxAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,15 +7,20 @@
 
 // all includes and forward declarations necessary for non-integral types below
-#include "Actions/Values.hpp"
-#include "Box.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/RealSpaceMatrixSymmetricValidator.hpp"
+#include "Parameters/Validators/Specific/RealSpaceMatrixInvertibleValidator.hpp"
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (Box)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (RealSpaceMatrix)
 #define paramtokens ("change-box")
 #define paramdescriptions ("symmetrc matrix of the new simulation domain")
 #undef paramdefaults
 #define paramreferences (cell_size)
+#define paramvalids \
+(RealSpaceMatrixSymmetricValidator() && RealSpaceMatrixInvertibleValidator())
 
 #define statetypes (std::string)
